package de.unibi.airobots.bonsai.actuators;

import java.io.IOException;

import de.unibi.airobots.bonsai.core.Actuator;

/**
 * Interface for actuator that start and stops processing of components.
 * 
 * @author lziegler
 */
public interface StartStopActuator extends Actuator {

    /**
     * Start processing.
     * 
     * @throws IOException
     *             communication error
     */
    void startProcessing() throws IOException;
    
    /**
     * Stop processing.
     * 
     * @throws IOException
     *             communication error
     */
    void stopProcessing() throws IOException;
    
}
