package de.unibi.airobots.bonsai.examples;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.JPanel;

import net.sf.xcf.MethodNotFoundException;
import net.sf.xcf.RemoteServer;
import net.sf.xcf.UserException;
import net.sf.xcf.XcfManager;
import net.sf.xcf.event.XcfEvent;
import net.sf.xcf.event.system.SystemEventAdapter;
import net.sf.xcf.event.system.AdditionEvent;
import net.sf.xcf.transport.XOPData;
import net.sf.xcf.xml.SyntaxException;

import org.apache.log4j.BasicConfigurator;

import de.unibi.airobots.bonsai.xcf.ConnectionErrorResistantRemoteServer;
import de.unibi.airobots.bonsai.xcf.RemoteServerReconnectableManager;

public class SensorFusionRemote extends JPanel implements ActionListener {

    private JCheckBox c;
    private RemoteServer rSrv;

    public SensorFusionRemote() {
        //super("MultiSensorFusion-Remote");
        //this.setLayout(new BorderLayout());
        BasicConfigurator.configure();

        try {
            // create remote server
            // get registered sensors
            String serverName = "MultiSensorFusion";
            final XcfManager manager = XcfManager.createXcfManager();
            manager.addListener(new SystemEventAdapter() {

                @Override
                public void handleEvent(AdditionEvent e) {
                    //if (e.getUri().equalsIgnoreCase(
                    //        "MSFServer")) {
                        synchronized (manager) {
                            manager.notifyAll();
                        }
                        //System.out.println(e.getData().getDocumentAsText());
                    //}
                }
            });
            try {
                System.out.println("Waiting for ExampleServer...");
                synchronized (manager) {
                    manager.wait();
                }
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            rSrv = manager.createRemoteServer("MSFServer");
            XOPData input = new XOPData();
            XOPData result;
            input
                    .setDocument("<?xml version=\"1.0\"?><XCF val=\"Hello World\"/>");
            XOPData res;
            res = rSrv.callMethod("getSensors", input);
            if (res != null) {
                // TODO fix getServerName
                // System.out.println("Server with name "+ rSrv.getServerName()
                // +
                // " is alive and we received the following response: ");
                System.out.println("Response is: " + res.getDocumentAsText());
                for (int i = 0; i < res.getDocument().getChild(0).getChildCount(); i+=2) {
                    String name = res.getDocument().getChild(0).getChild(i).getChild(0).getValue();
                    boolean active = res.getDocument().getChild(0).getChild(i).getChild(1).getValue().equals("1");
                    JCheckBox c = new JCheckBox(name);
                    c.setSelected(active);
                    c.setVisible(true);
                    c.setActionCommand(name);
                    c.addActionListener(this);
                    this.add(c);
                    System.out.println("Adding checkbox: " + name + "(" + active + ")");
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        this.setVisible(true);
    }

    @Override
    public void actionPerformed(ActionEvent ev) {
        XOPData in = new XOPData();
        try {
            in.setDocument("<?xml version=\"1.0\"?><SENSOR>" + ev.getActionCommand() + "</SENSOR>");
            rSrv.callMethod("xcfToggleSensor",in);
        } catch (SyntaxException e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        } catch (MethodNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (UserException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
}
